/*
*	Copyright (C) 2010
*	Chair of Process Control Engineering,
*	Aachen University of Technology.
*	All rights reserved.
*
*	Redistribution and use in source and binary forms, with or without
*	modification, are permitted provided that the following conditions
*	are met:
*	1. Redistributions of source code must retain the above copyright
*	   notice, this list of conditions and the following disclaimer.
*	2. Redistributions in binary form must print or display the above
*	   copyright notice either during startup or must have a means for
*	   the user to view the copyright notice.
*	3. Redistributions in binary form must reproduce the above copyright
*	   notice, this list of conditions and the following disclaimer in
*		the documentation and/or other materials provided with the
*		distribution.
*	4. Neither the name of the Chair of Process Control Engineering nor
*		the name of the Aachen University of Technology may be used to
*		endorse or promote products derived from this software without
*		specific prior written permission.
*
*	THIS SOFTWARE IS PROVIDED BY THE CHAIR OF PROCESS CONTROL ENGINEERING
*	``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
*	LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
*	A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE CHAIR OF
*	PROCESS CONTROL ENGINEERING BE LIABLE FOR ANY DIRECT, INDIRECT,
*	INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
*	BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
*	OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
*	AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
*	LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
*	WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
*	POSSIBILITY OF SUCH DAMAGE.
*/
/******************************************************************************
*
*   FILE
*   ----
*   LIMIT.c
*
*   History
*   -------
*   2010-11-30   File created
*
*******************************************************************************
*
*   This file is generated by the 'fb_builder' command
*
******************************************************************************/


#ifndef OV_COMPILE_LIBRARY_iec61131stdfb
#define OV_COMPILE_LIBRARY_iec61131stdfb
#endif


#include "iec61131stdfb.h"
#include "stdfb_macros.h"
#include "libov/ov_macros.h"
#include "libov/ov_logfile.h"
#include "helper.h"

#define OV_DEBUG


OV_DLLFNCEXPORT OV_RESULT iec61131stdfb_LIMIT_MN_set(
    OV_INSTPTR_iec61131stdfb_LIMIT          pobj,
    const OV_ANY*  value
) {
    if((pobj->v_MN.value.vartype & OV_VT_KSMASK) == (value->value.vartype & OV_VT_KSMASK))
		return ov_variable_setanyvalue(&pobj->v_MN, value);
	else
	{
		if(iec61131stdfb_isConnected(Ov_PtrUpCast(fb_functionblock, pobj)))
			return OV_ERR_NOACCESS;
		else
		{
			if(pobj->v_IN.value.vartype & OV_VT_ISVECTOR)
			{
				if((pobj->v_IN.value.vartype & OV_VT_KSMASK & (~OV_VT_ISVECTOR)) == (value->value.vartype & OV_VT_KSMASK))
				{
					iec61131stdfb_freeVec(&pobj->v_MN);
					iec61131stdfb_freeVec(&pobj->v_MX);
					
					pobj->v_MX.value.vartype = value->value.vartype;
					return ov_variable_setanyvalue(&pobj->v_MN, value);
				}
				else
				{
					iec61131stdfb_freeVec(&pobj->v_MN);
					iec61131stdfb_freeVec(&pobj->v_MX);
					iec61131stdfb_freeVec(&pobj->v_IN);
					iec61131stdfb_freeVec(&pobj->v_OUT);
					
					pobj->v_MX.value.vartype = value->value.vartype;
					pobj->v_IN.value.vartype = value->value.vartype;
					pobj->v_OUT.value.vartype = value->value.vartype;
					return ov_variable_setanyvalue(&pobj->v_MN, value);
				}
			}
			else
			{
				iec61131stdfb_freeVec(&pobj->v_MN);
				iec61131stdfb_freeVec(&pobj->v_MX);
				iec61131stdfb_freeVec(&pobj->v_IN);
				iec61131stdfb_freeVec(&pobj->v_OUT);
				
				pobj->v_MX.value.vartype = value->value.vartype;
				pobj->v_IN.value.vartype = value->value.vartype;
				pobj->v_OUT.value.vartype = value->value.vartype;
				return ov_variable_setanyvalue(&pobj->v_MN, value);
			}
		}
	}
}

OV_DLLFNCEXPORT OV_RESULT iec61131stdfb_LIMIT_IN_set(
    OV_INSTPTR_iec61131stdfb_LIMIT          pobj,
    const OV_ANY*  value
) {
    if((pobj->v_IN.value.vartype & OV_VT_KSMASK) == (value->value.vartype & OV_VT_KSMASK))
		return ov_variable_setanyvalue(&pobj->v_IN, value);
	else
	{
		if(iec61131stdfb_isConnected(Ov_PtrUpCast(fb_functionblock, pobj)))
			return OV_ERR_NOACCESS;
		else
		{
			iec61131stdfb_freeVec(&pobj->v_MN);
			iec61131stdfb_freeVec(&pobj->v_MX);
			iec61131stdfb_freeVec(&pobj->v_IN);
			iec61131stdfb_freeVec(&pobj->v_OUT);
				
			pobj->v_MX.value.vartype = value->value.vartype;
			pobj->v_MN.value.vartype = value->value.vartype;
			pobj->v_OUT.value.vartype = value->value.vartype;
			return ov_variable_setanyvalue(&pobj->v_IN, value);
		}
	}
}

OV_DLLFNCEXPORT OV_RESULT iec61131stdfb_LIMIT_MX_set(
    OV_INSTPTR_iec61131stdfb_LIMIT          pobj,
    const OV_ANY*  value
) {
    if((pobj->v_MX.value.vartype & OV_VT_KSMASK) == (value->value.vartype & OV_VT_KSMASK))
		return ov_variable_setanyvalue(&pobj->v_MX, value);
	else
	{
		if(iec61131stdfb_isConnected(Ov_PtrUpCast(fb_functionblock, pobj)))
			return OV_ERR_NOACCESS;
		else
		{
			if(pobj->v_IN.value.vartype & OV_VT_ISVECTOR)
			{
				if((pobj->v_IN.value.vartype & OV_VT_KSMASK & (~OV_VT_ISVECTOR)) == (value->value.vartype & OV_VT_KSMASK))
				{
					iec61131stdfb_freeVec(&pobj->v_MN);
					iec61131stdfb_freeVec(&pobj->v_MX);
					
					pobj->v_MN.value.vartype = value->value.vartype;
					return ov_variable_setanyvalue(&pobj->v_MX, value);
				}
				else
				{
					iec61131stdfb_freeVec(&pobj->v_MN);
					iec61131stdfb_freeVec(&pobj->v_MX);
					iec61131stdfb_freeVec(&pobj->v_IN);
					iec61131stdfb_freeVec(&pobj->v_OUT);
					
					pobj->v_MN.value.vartype = value->value.vartype;
					pobj->v_IN.value.vartype = value->value.vartype;
					pobj->v_OUT.value.vartype = value->value.vartype;
					return ov_variable_setanyvalue(&pobj->v_MX, value);
				}
			}
			else
			{
				iec61131stdfb_freeVec(&pobj->v_MN);
				iec61131stdfb_freeVec(&pobj->v_MX);
				iec61131stdfb_freeVec(&pobj->v_IN);
				iec61131stdfb_freeVec(&pobj->v_OUT);
				
				pobj->v_MN.value.vartype = value->value.vartype;
				pobj->v_IN.value.vartype = value->value.vartype;
				pobj->v_OUT.value.vartype = value->value.vartype;
				return ov_variable_setanyvalue(&pobj->v_MX, value);
			}
		}
	}
}

OV_DLLFNCEXPORT OV_ANY* iec61131stdfb_LIMIT_OUT_get(
    OV_INSTPTR_iec61131stdfb_LIMIT          pobj
) {
    return &pobj->v_OUT;
}


OV_DLLFNCEXPORT void iec61131stdfb_LIMIT_destructor(OV_INSTPTR_ov_object pobj) {

	OV_INSTPTR_iec61131stdfb_LIMIT pinst = Ov_StaticPtrCast(iec61131stdfb_LIMIT, pobj);
	
	iec61131stdfb_freeVec(&pinst->v_IN);
	iec61131stdfb_freeVec(&pinst->v_MN);
	iec61131stdfb_freeVec(&pinst->v_MX);
	iec61131stdfb_freeVec(&pinst->v_OUT);
	fb_functionblock_destructor(pobj);
}


OV_DLLFNCEXPORT OV_RESULT iec61131stdfb_LIMIT_constructor(OV_INSTPTR_ov_object pobj) {

	OV_RESULT res;
	OV_INSTPTR_iec61131stdfb_LIMIT pinst = Ov_StaticPtrCast(iec61131stdfb_LIMIT, pobj);
	
	res = fb_functionblock_constructor(pobj);
	
	if(Ov_OK(res))
	{
		pinst->v_IN.value.valueunion.val_double = 0;
		pinst->v_MX.value.valueunion.val_double = 0;
		pinst->v_MN.value.valueunion.val_double = 0;
		pinst->v_OUT.value.valueunion.val_double = 0;
		pinst->v_IN.value.vartype = OV_VT_SINGLE;
		pinst->v_MX.value.vartype = OV_VT_SINGLE;
		pinst->v_MN.value.vartype = OV_VT_SINGLE;
		pinst->v_OUT.value.vartype = OV_VT_SINGLE;
		return OV_ERR_OK;
	}
	else
		return res;
}

OV_DLLFNCEXPORT void iec61131stdfb_LIMIT_typemethod(
	OV_INSTPTR_fb_functionblock	pfb,
	OV_TIME						*pltc
) {
    /*    
    *   local variables
    */
	
	unsigned int i;
	
    OV_INSTPTR_iec61131stdfb_LIMIT pinst = Ov_StaticPtrCast(iec61131stdfb_LIMIT, pfb);
	
	iec61131stdfb_freeVec(&pinst->v_OUT);
	
	if(!(pinst->v_IN.value.vartype & OV_VT_ISVECTOR))	//handling scalars
	{
		
		switch(pinst->v_IN.value.vartype & OV_VT_KSMASK)
		{
			STDFB_LIMIT(BOOL, bool);
			STDFB_LIMIT(BYTE, byte);
			STDFB_LIMIT(UINT, uint);
			STDFB_LIMIT(INT, int);
			STDFB_LIMIT(SINGLE, single);
			STDFB_LIMIT(DOUBLE, double);
			
			case OV_VT_TIME:
				if(ov_time_compare(&pinst->v_MN.value.valueunion.val_time, &pinst->v_MX.value.valueunion.val_time) <= 0)
				{
					pinst->v_OUT.value.vartype = OV_VT_TIME;
					
					if(ov_time_compare(&pinst->v_IN.value.valueunion.val_time, &pinst->v_MX.value.valueunion.val_time) > 0)
						pinst->v_OUT.value.valueunion.val_time = pinst->v_MX.value.valueunion.val_time;
					else
						if(ov_time_compare(&pinst->v_IN.value.valueunion.val_time, &pinst->v_MN.value.valueunion.val_time) < 0)
							pinst->v_OUT.value.valueunion.val_time = pinst->v_MN.value.valueunion.val_time;
						else
							pinst->v_OUT.value.valueunion.val_time = pinst->v_IN.value.valueunion.val_time;
				}
				else
				{
					ov_logfile_error("%s: minimum is larger than maximum", pinst->v_identifier);
					pinst->v_OUT.value.vartype = OV_VT_BOOL;
					pinst->v_OUT.value.valueunion.val_bool = 0;
					return;
				}
			break;
				
			case OV_VT_TIME_SPAN:
				if(STDFB_LE_TIME_SPAN(pinst->v_MN.value.valueunion.val_time_span, pinst->v_MX.value.valueunion.val_time_span))
				{
					pinst->v_OUT.value.vartype = OV_VT_TIME_SPAN;
					
					if(STDFB_LE_TIME_SPAN(pinst->v_IN.value.valueunion.val_time_span, pinst->v_MN.value.valueunion.val_time_span))
						pinst->v_OUT.value.valueunion.val_time_span = pinst->v_MN.value.valueunion.val_time_span;
					else
						if(STDFB_LE_TIME_SPAN(pinst->v_MX.value.valueunion.val_time_span, pinst->v_IN.value.valueunion.val_time_span))
							pinst->v_OUT.value.valueunion.val_time_span = pinst->v_MX.value.valueunion.val_time_span;
						else
							pinst->v_OUT.value.valueunion.val_time_span = pinst->v_IN.value.valueunion.val_time_span;
				}
				else
				{
					ov_logfile_error("%s: minimum is larger than maximum", pinst->v_identifier);
					pinst->v_OUT.value.vartype = OV_VT_BOOL;
					pinst->v_OUT.value.valueunion.val_bool = 0;
					return;
				}
			break;
			
			case OV_VT_STRING:
				if(ov_string_compare(pinst->v_MN.value.valueunion.val_string, pinst->v_MX.value.valueunion.val_string) <= 0)
				{
					pinst->v_OUT.value.vartype = OV_VT_STRING;
					if(ov_string_compare(pinst->v_IN.value.valueunion.val_string, pinst->v_MN.value.valueunion.val_string) < 0)
						if(Ov_Fail(ov_string_setvalue(&pinst->v_OUT.value.valueunion.val_string, pinst->v_MN.value.valueunion.val_string)))
						{
							ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
							return;
						}
						else
							;
					else
						if(ov_string_compare(pinst->v_IN.value.valueunion.val_string, pinst->v_MX.value.valueunion.val_string) > 0)
							if(Ov_Fail(ov_string_setvalue(&pinst->v_OUT.value.valueunion.val_string, pinst->v_MX.value.valueunion.val_string)))
							{
								ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
								return;
							}
							else
								;
						else
							if(Ov_Fail(ov_string_setvalue(&pinst->v_OUT.value.valueunion.val_string, pinst->v_IN.value.valueunion.val_string)))
							{
								ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
								return;
							}
				}
				else
				{
					ov_logfile_error("%s: minimum is larger than maximum", pinst->v_identifier);
					pinst->v_OUT.value.vartype = OV_VT_BOOL;
					pinst->v_OUT.value.valueunion.val_bool = 0;
					return;
				}
			break;
				
			default:
				ov_logfile_error("%s: limiting of given type not implemented", pinst->v_identifier);
				pinst->v_OUT.value.vartype = OV_VT_BOOL;
				pinst->v_OUT.value.valueunion.val_bool = 0;
				return;
				
		}
		
		
	}
	else			//handling vectors
	{
		if((((pinst->v_IN.value.vartype & (~OV_VT_ISVECTOR)) & OV_VT_KSMASK) == (pinst->v_MN.value.vartype & OV_VT_KSMASK))	
			|| ((pinst->v_IN.value.vartype & OV_VT_KSMASK) == (pinst->v_MN.value.vartype & OV_VT_KSMASK)))	//scalars of same type also allowed as MN / MX
		{
			switch(pinst->v_IN.value.vartype & OV_VT_KSMASK)	//no test if min is smaller than max!!
			{
				STDFB_LIMIT_VEC(BOOL, bool);
				STDFB_LIMIT_VEC(BYTE, byte);
				STDFB_LIMIT_VEC(UINT, uint);
				STDFB_LIMIT_VEC(INT, int);
				STDFB_LIMIT_VEC(SINGLE, single);
				STDFB_LIMIT_VEC(DOUBLE, double);
				
				case OV_VT_STRING_VEC:
					pinst->v_OUT.value.vartype = OV_VT_STRING_VEC;
					if((pinst->v_MN.value.vartype & OV_VT_ISVECTOR))
					{	
						if(Ov_Fail(Ov_SetDynamicVectorLength(&pinst->v_OUT.value.valueunion.val_string_vec, pinst->v_IN.value.valueunion.val_string_vec.veclen, STRING)))
						{
							ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
							return;
						}
						for(i=0; i < pinst->v_IN.value.valueunion.val_string_vec.veclen; i++)
						{
							if(i < pinst->v_MN.value.valueunion.val_string_vec.veclen)
							{
								if(ov_string_compare(pinst->v_IN.value.valueunion.val_string_vec.value[i], pinst->v_MN.value.valueunion.val_string_vec.value[i]) < 0)
								{
									if(Ov_Fail(ov_string_setvalue(&pinst->v_OUT.value.valueunion.val_string_vec.value[i], pinst->v_MN.value.valueunion.val_string_vec.value[i])))
									{
										ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
										return;
									}
									continue;
								}
							}
							else
								if(ov_string_compare(pinst->v_IN.value.valueunion.val_string_vec.value[i], "") < 0)
								{
									ov_string_setvalue(&pinst->v_OUT.value.valueunion.val_string_vec.value[i], "");
									continue;
								}
							if(i < pinst->v_MX.value.valueunion.val_string_vec.veclen)
							{
								if(ov_string_compare(pinst->v_IN.value.valueunion.val_string_vec.value[i], pinst->v_MX.value.valueunion.val_string_vec.value[i]) > 0)
								{
									if(Ov_Fail(ov_string_setvalue(&pinst->v_OUT.value.valueunion.val_string_vec.value[i], pinst->v_MX.value.valueunion.val_string_vec.value[i])))
									{
										ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
										return;
									}
									continue;
								}
							}
							else
								if(ov_string_compare(pinst->v_IN.value.valueunion.val_string_vec.value[i], "") > 0)
								{
									ov_string_setvalue(&pinst->v_OUT.value.valueunion.val_string_vec.value[i], "");
									continue;
								}
							if(Ov_Fail(ov_string_setvalue(&pinst->v_OUT.value.valueunion.val_string_vec.value[i], pinst->v_IN.value.valueunion.val_string_vec.value[i])))
							{
								ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
								return;
							}
						}
					}
					else
					{
						if(Ov_Fail(Ov_SetDynamicVectorLength(&pinst->v_OUT.value.valueunion.val_string_vec, pinst->v_IN.value.valueunion.val_string_vec.veclen, STRING)))
						{
							ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
							return;
						}
						for(i=0; i < pinst->v_IN.value.valueunion.val_string_vec.veclen; i++)
						{
							if(ov_string_compare(pinst->v_IN.value.valueunion.val_string_vec.value[i], pinst->v_MN.value.valueunion.val_string) < 0)
								if(Ov_Fail(ov_string_setvalue(&pinst->v_OUT.value.valueunion.val_string_vec.value[i], pinst->v_MN.value.valueunion.val_string)))
								{
									ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
									return;
								}
								else
									continue;
							else		
								if(ov_string_compare(pinst->v_IN.value.valueunion.val_string_vec.value[i], pinst->v_MX.value.valueunion.val_string) > 0)
									if(Ov_Fail(ov_string_setvalue(&pinst->v_OUT.value.valueunion.val_string_vec.value[i], pinst->v_MX.value.valueunion.val_string)))
									{
										ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
										return;
									}
									else
										continue;
								else		
									if(Ov_Fail(ov_string_setvalue(&pinst->v_OUT.value.valueunion.val_string_vec.value[i], pinst->v_IN.value.valueunion.val_string_vec.value[i])))
									{
										ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
										return;
									}
						}
					}
				break;
					
				case OV_VT_TIME_VEC:
					pinst->v_OUT.value.vartype = OV_VT_TIME_VEC;
					if((pinst->v_MN.value.vartype & OV_VT_ISVECTOR))
					{
						if(Ov_Fail(Ov_SetDynamicVectorLength(&pinst->v_OUT.value.valueunion.val_time_vec, pinst->v_IN.value.valueunion.val_time_vec.veclen, TIME)))
						{
							ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
						return;
						}
						for(i=0; i < pinst->v_IN.value.valueunion.val_time_vec.veclen; i++)
						{
							if(i < pinst->v_MN.value.valueunion.val_time_vec.veclen)
							{
								if(ov_time_compare(&pinst->v_IN.value.valueunion.val_time_vec.value[i], &pinst->v_MN.value.valueunion.val_time_vec.value[i]) < 0)
								{
									pinst->v_OUT.value.valueunion.val_time_vec.value[i] = pinst->v_MN.value.valueunion.val_time_vec.value[i];
									continue;
								}
							}
							else
								if((pinst->v_IN.value.valueunion.val_time_vec.value[i].secs < 0) || (pinst->v_IN.value.valueunion.val_time_vec.value[i].usecs < 0))
								{
									pinst->v_OUT.value.valueunion.val_time_vec.value[i].secs = 0;
									pinst->v_OUT.value.valueunion.val_time_vec.value[i].usecs = 0;
									continue;
								}
							if(i < pinst->v_MX.value.valueunion.val_time_vec.veclen)
							{
								if(ov_time_compare(&pinst->v_IN.value.valueunion.val_time_vec.value[i], &pinst->v_MX.value.valueunion.val_time_vec.value[i]) > 0)
								{
									pinst->v_OUT.value.valueunion.val_time_vec.value[i] = pinst->v_MX.value.valueunion.val_time_vec.value[i];
									continue;
								}
							}
							else
								if((pinst->v_IN.value.valueunion.val_time_vec.value[i].secs > 0) || (pinst->v_IN.value.valueunion.val_time_vec.value[i].usecs > 0))
								{
									pinst->v_OUT.value.valueunion.val_time_vec.value[i].secs = 0;
									pinst->v_OUT.value.valueunion.val_time_vec.value[i].usecs = 0;
									continue;
								}
							pinst->v_OUT.value.valueunion.val_time_vec.value[i] = pinst->v_IN.value.valueunion.val_time_vec.value[i];
						}
					}
					else
					{
						if(Ov_Fail(Ov_SetDynamicVectorLength(&pinst->v_OUT.value.valueunion.val_time_vec, pinst->v_IN.value.valueunion.val_time_vec.veclen, TIME)))
						{
							ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
						return;
						}
						for(i=0; i < pinst->v_IN.value.valueunion.val_time_vec.veclen; i++)
						{
							if(ov_time_compare(&pinst->v_IN.value.valueunion.val_time_vec.value[i], &pinst->v_MN.value.valueunion.val_time) < 0)
								pinst->v_OUT.value.valueunion.val_time_vec.value[i] = pinst->v_MN.value.valueunion.val_time;
							else
								if(ov_time_compare(&pinst->v_IN.value.valueunion.val_time_vec.value[i], &pinst->v_MX.value.valueunion.val_time) > 0)
									pinst->v_OUT.value.valueunion.val_time_vec.value[i] = pinst->v_MX.value.valueunion.val_time;
								else
									pinst->v_OUT.value.valueunion.val_time_vec.value[i] = pinst->v_IN.value.valueunion.val_time_vec.value[i];
						}
					}
				break;
					
				case OV_VT_TIME_SPAN_VEC:
					pinst->v_OUT.value.vartype = OV_VT_TIME_SPAN_VEC;
					if((pinst->v_MN.value.vartype & OV_VT_ISVECTOR))
					{
						if(Ov_Fail(Ov_SetDynamicVectorLength(&pinst->v_OUT.value.valueunion.val_time_span_vec, pinst->v_IN.value.valueunion.val_time_span_vec.veclen, TIME_SPAN)))
						{
							ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
						return;
						}
						for(i=0; i < pinst->v_IN.value.valueunion.val_time_span_vec.veclen; i++)
						{
							if(i < pinst->v_MN.value.valueunion.val_time_span_vec.veclen)
							{
								if(STDFB_LE_TIME_SPAN(pinst->v_IN.value.valueunion.val_time_span_vec.value[i], pinst->v_MN.value.valueunion.val_time_span_vec.value[i]))
								{
									pinst->v_OUT.value.valueunion.val_time_span_vec.value[i] = pinst->v_MN.value.valueunion.val_time_span_vec.value[i];
									continue;
								}
							}
							else
								if((pinst->v_IN.value.valueunion.val_time_span_vec.value[i].secs < 0) 
									|| ((pinst->v_IN.value.valueunion.val_time_span_vec.value[i].usecs < 0) && (pinst->v_IN.value.valueunion.val_time_span_vec.value[i].secs == 0)))
								{
									pinst->v_OUT.value.valueunion.val_time_span_vec.value[i].secs = 0;
									pinst->v_OUT.value.valueunion.val_time_span_vec.value[i].usecs = 0;
									continue;
								}
							if(i < pinst->v_MX.value.valueunion.val_time_span_vec.veclen)
							{
								if(STDFB_LE_TIME_SPAN(pinst->v_MX.value.valueunion.val_time_span_vec.value[i], pinst->v_IN.value.valueunion.val_time_span_vec.value[i]))
								{
									pinst->v_OUT.value.valueunion.val_time_span_vec.value[i] = pinst->v_MX.value.valueunion.val_time_span_vec.value[i];
									continue;
								}
							}
							else
								if(((pinst->v_IN.value.valueunion.val_time_span_vec.value[i].secs > 0) 
									|| ((pinst->v_IN.value.valueunion.val_time_span_vec.value[i].usecs > 0) && (pinst->v_IN.value.valueunion.val_time_span_vec.value[i].secs == 0))))
								{
									pinst->v_OUT.value.valueunion.val_time_span_vec.value[i].secs = 0;
									pinst->v_OUT.value.valueunion.val_time_span_vec.value[i].usecs = 0;
									continue;
								}
							pinst->v_OUT.value.valueunion.val_time_span_vec.value[i] = pinst->v_IN.value.valueunion.val_time_span_vec.value[i];
						}
					}
					else
					{
						if(Ov_Fail(Ov_SetDynamicVectorLength(&pinst->v_OUT.value.valueunion.val_time_span_vec, pinst->v_IN.value.valueunion.val_time_span_vec.veclen, TIME_SPAN)))
						{
							ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
						return;
						}
						for(i=0; i < pinst->v_IN.value.valueunion.val_time_span_vec.veclen; i++)
						{
							if(STDFB_LE_TIME_SPAN(pinst->v_IN.value.valueunion.val_time_span_vec.value[i], pinst->v_MN.value.valueunion.val_time_span))
								pinst->v_OUT.value.valueunion.val_time_span_vec.value[i] = pinst->v_MN.value.valueunion.val_time_span;
							else
								if(STDFB_LE_TIME_SPAN(pinst->v_MX.value.valueunion.val_time_span, pinst->v_IN.value.valueunion.val_time_span_vec.value[i]))
									pinst->v_OUT.value.valueunion.val_time_span_vec.value[i] = pinst->v_MX.value.valueunion.val_time_span;
								else
									pinst->v_OUT.value.valueunion.val_time_span_vec.value[i] = pinst->v_IN.value.valueunion.val_time_span_vec.value[i];
						}
					}
				break;
				
				default:
					ov_logfile_error("%s: limiting of given type not implemented", pinst->v_identifier);
					pinst->v_OUT.value.vartype = OV_VT_BOOL;
					pinst->v_OUT.value.valueunion.val_bool = 0;
					return;
				}
		}
		else
		{
			ov_logfile_error("%s: trying to use inputs of different types on LIMIT-block", pinst->v_identifier);
			pinst->v_OUT.value.vartype = OV_VT_BOOL;
			pinst->v_OUT.value.valueunion.val_bool = 0;
			return;
		}
		
			/************** handling states ********************************/
		
	STDFB_STATE(IN);
	
	/***************** handling timestamps ************************/
	STDFB_TIMESTAMP(IN);
		
		
	}
	
    return;
}

