/*
*   $Id: mklibtab.c,v 1.1 1999-07-19 15:01:53 dirk Exp $
*
*   Copyright (C) 1998-1999
*   Lehrstuhl fuer Prozessleittechnik,
*   RWTH Aachen, D-52056 Aachen, Germany.
*   All rights reserved.
*
*   Author: Dirk Meyer <dirk@plt.rwth-aachen.de>
*
*   This file is part of the ACPLT/OV Package which is licensed as open
*   source under the Artistic License; you can use, redistribute and/or
*   modify it under the terms of that license.
*
*   You should have received a copy of the Artistic License along with
*   this Package; see the file ARTISTIC-LICENSE. If not, write to the
*   Copyright Holder.
*
*   THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
*   WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES
*   OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*/
/*
*	History:
*	--------
*	01-Jul-1999 Dirk Meyer <dirk@plt.rwth-aachen.de>: File created.
*/

#include <stdio.h>
#include <stdlib.h>

int main(int argc, char** argv) {
	int i;
	FILE* fp;
	if(argc < 3) {
		return EXIT_FAILURE;
	}
	fp = fopen(argv[1], "w");
	if(!fp) {
		return EXIT_FAILURE;
	}
	fprintf(fp, "/*\n");
	fprintf(fp, "*   This file was generated by ACPLT/OV MkLibTab.\n");
	fprintf(fp, "*\n");
	fprintf(fp, "*   DO NOT EDIT THIS FILE!\n");
	fprintf(fp, "*/\n");
	fprintf(fp, "\n");
	fprintf(fp, "#include \"libov/ov_library.h\"\n");
	fprintf(fp, "\n");
	fprintf(fp, "#if OV_STATIC_LIBRARIES\n");
	fprintf(fp, "\n");
	for(i=2; i<argc; i++) {
		fprintf(fp, "Ov_DeclareStaticLibrary(%s);\n", argv[i]);
	}
	fprintf(fp, "\n");
	fprintf(fp, "Ov_BeginStaticLibraryTable\n");
	for(i=2; i<argc; i++) {
		fprintf(fp, "Ov_DefineStaticLibrary(%s)\n", argv[i]);
	}
	fprintf(fp, "Ov_EndStaticLibraryTable;\n");
	fprintf(fp, "\n");
	fprintf(fp, "#endif\n");
	fprintf(fp, "\n");
	fprintf(fp, "/*\n");
	fprintf(fp, "*	End of File\n");
	fprintf(fp, "*/\n");
	fclose(fp);
	return EXIT_SUCCESS;
}
